=== doc/requirements.txt ===
Jinja2==3.1.2
Pygments>=2.12.0
docutils==0.17.1
sphinx_rtd_theme==1.0.0
Sphinx==5.1.1
GitPython==3.1.27
