=== src/packet_analysis/protocol/CMakeLists.txt ===
add_subdirectory(root)
add_subdirectory(skip)

add_subdirectory(null)
add_subdirectory(ethernet)
add_subdirectory(vlan)
add_subdirectory(pppoe)
add_subdirectory(ppp_serial)
add_subdirectory(ieee802_11)
add_subdirectory(ieee802_11_radio)
add_subdirectory(fddi)
add_subdirectory(nflog)
add_subdirectory(mpls)
add_subdirectory(linux_sll)
add_subdirectory(linux_sll2)

add_subdirectory(arp)
add_subdirectory(ip)
add_subdirectory(udp)
add_subdirectory(tcp)
add_subdirectory(icmp)
add_subdirectory(vntag)

add_subdirectory(gre)
add_subdirectory(iptunnel)
add_subdirectory(ayiya)
add_subdirectory(geneve)
add_subdirectory(vxlan)
add_subdirectory(teredo)
add_subdirectory(gtpv1)
