=== debian/changelog ===
zeek (5.1.1-0kali3) kali-dev; urgency=medium

  * Use --max-parallel=4 to fix build on arm64

 -- Sophie Brun <sophie@offensive-security.com>  Sat, 15 Jul 2023 21:04:07 +0200

zeek (5.1.1-0kali2) kali-dev; urgency=medium

  * Use --max-parallel=maximum to fix build on arm64

 -- Sophie Brun <sophie@offensive-security.com>  Sat, 15 Jul 2023 20:49:18 +0200

zeek (5.1.1-0kali1) kali-dev; urgency=medium

  * New upstream version 5.1.1
  * Refresh patch
  * Adapt build
  * Use embedded version of rapidjson
  * Add missing build-dep libfl-dev
  * Remove failing test
  * Use debhelper-compat 13 and update install

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 24 Jan 2023 16:23:00 +0100
