=== debian/control ===
Source: zeek
Section: net
Priority: optional
Maintainer: Hilko Bengen <bengen@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 binpac (>= 0.54-2~),
 btest,
 bifcl (>= 1.2+rel),
 bison,
 flex,
 rsync,
 libbroker-dev, libcaf-dev (>= 0.17),
 libcurl4-openssl-dev | libcurl-dev,
 doctest-dev,
 libgoogle-perftools-dev,
 libkrb5-dev,
 libmaxminddb-dev,
 libparaglob-dev,
 libpcap0.8-dev | libpcap-dev,
 libreadline-dev,
 libsqlite3-dev,
 libssl-dev (>= 1.1),
 libtsl-ordered-map-dev,
 libfl-dev,
 libxml2-dev,
# rapidjson-dev,
 zlib1g-dev,
Standards-Version: 4.5.0
Homepage: http://www.zeek.org/
Vcs-Git: https://salsa.debian.org/bro-team/zeek.git
Vcs-Browser: https://salsa.debian.org/bro-team/zeek

Package: zeek
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 zeek-common (>= ${source:Version}),
Conflicts: bro (<< 3.0.0)
Replaces: bro (<< 3.0.0)
Built-Using: ${misc:Built-Using},
Description: passive network traffic analyzer
 Zeek is primarily a security monitor that inspects all traffic on a link in
 depth for signs of suspicious activity. More generally, however, Zeek
 supports a wide range of traffic analysis tasks even outside of the
 security domain, including performance measurements and helping with
 trouble-shooting.
 .
 Zeek comes with built-in functionality for a range of analysis and
 detection tasks, including detecting malware by interfacing to external
 registries, reporting vulnerable versions of software seen on the network,
 identifying popular web applications, detecting SSH brute-forcing,
 validating SSL certificate chains, among others.

Package: zeek-common
Architecture: all
Depends: ${misc:Depends}
Conflicts: bro-common (<< 3.0.0)
Replaces: bro-common (<< 3.0.0)
Built-Using: ${misc:Built-Using},
Description: passive network traffic analyzer -- architecture-independent parts
 This package contains the architecture-independent parts for the Zeek
 network security monitor.

Package: zeek-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, zeek (>= ${source:Version})
Conflicts: bro-dev (<< 3.0.0)
Replaces: bro-dev (<< 3.0.0)
Built-Using: ${misc:Built-Using},
Description: passive network traffic analyzer -- development files
 This package contains the header files needed for building extensions
 for the Zeek network security monitor.

Package: bro
Section: oldlibs
Architecture: all
Depends: zeek (>= ${source:Version}), ${misc:Depends},
Description: passive network traffic analyzer - Transitional package
 Bro has been renamed to Zeek. This is a transitional package
 providing symlinks (/usr/bin/bro, /usr/bin/bro-config) for
 compatibility with existing scripts and integrations.
 .
 This package can be safely removed if those symlinks are no longer
 used.
